#--------------------- 'backward search' Module ----------------------
$BW = 1;

sub bwopen{
    my($fh, $ext) = @_;

    (&openbfile($fh, "$DbPath.$ext") >= $HashTime &&
     &openbfile($fh . 'INDEX', "$DbPath.$ext" . 'i') >= $HashTime);
}

sub bwclose{
    my($fh, $ext) = @_;
    &closefile('MB');
    &closefile('MBINDEX');
    &closefile('SB');
    &closefile('SBINDEX');
    &mb_init;
    &sb_init;
}

sub w_bw{
    local($origkey, *score, $key, $forward) = @_;
    my $pat = $key;
    my $byt = !(0x80 & ord $pat);
    my $sft = ($forward && !$byt);

    $pat =~ s/([\xa1-\xfe][\xa1-\xfe])/\xff$1/g if $sft;
    $pat =~ s/([\x00-\x7f]+)/quotemeta($1)/ge;
    $pat .= "\$" unless $forward;

    my $totalhit;

    if ($CACHE){
        &cache_init;
        $totalhit = &cache_read_word("bw $pat", *score, $origkey, $pat, $sft);
        return ($origkey, '', $totalhit) if $totalhit >= 0;
    }
    $totalhit = 0;

    my $ndx = 0;
    my $offset = 0;
    unless ($byt){
        my $l = 0;
        $ndx = $DbNdx{'INDEXINDEX'} - 1;
        while ($l < $ndx){
            my $buf = &readindexindex(my $x = ($l + $ndx) >> 1);
            if (0x80 & ord $buf){
                $ndx = $x;
            }else{
                $l = $x + 1;
            }
        }
        if ($DbVer2){
            $offset = &indexpointer('WORDINDEX', $ndx);
        }else{
            $offset = &indexpointer('INDEXINDEX', $ndx);
        }
    }

    my $direct = ($DbSize{'WORD'} && !$WORD);
    my @ndx;
    seek('WORD', $offset, 0) if $direct;
    while ($ndx < $DbNdx{'INDEXINDEX'}){
        my $str = $direct? <WORD>: &readindexindex($ndx);
        chomp $str;
        $str =~ s/([\xa1-\xfe][\xa1-\xfe])/\xff$1/g if $sft;
        last if $byt and 0x80 & ord $str;
        if ($str =~ /$pat/i){
            &ssub(\$totalhit, $ndx, *score, $origkey, $pat, $sft);
            push(@ndx, $ndx) if $CACHE;
        }
        $ndx++;
    }
    &cache_write_word("bw $pat", @ndx) if $CACHE && @ndx;
    return ($origkey, '', $totalhit);
}

sub bwsearch{
    local($origkey, *score, $key, $forward, $fh) = @_;
    local(%kdat, %ktmp);
    local(%ldat, %ltmp);
    my($str, $ini) = ($key, 1);
    my($x, $l, $r, $buf, $totalhit);
    my($bstr, $pre, $match, $h, $c1, $c2);
    my($indexsub, $fhi, $charsub);

    my($bw) = ($fh eq 'MB');

    $indexsub = \&mbindex, $charsub = \&mbchars if $fh eq 'MB';
    $indexsub = \&sbindex, $charsub = \&sbchars if $fh eq 'SB';
    $fhi = $fh . 'INDEX';

    $str =~ s/([\x00-\x7f]+)/quotemeta($1)/ge;
    $str .= "\$" if !$forward;
    $key =~ s/[^a-zA-Z0-9\x80-\xff]/_/g;

    while (($c1, $c2) = &$charsub($key)){
        $pre .= "$c1$c2";
        $x = &$indexsub($c1, $c2);
        $l = &indexpointer($fhi, $x++);

        if ($IntType ne 'w'){
            $l *= $IntSize;
            $r = &lastNdx($fh, $x) * $IntSize;
        }else{
            $r = &lastSize($fh, $x);
        }

        %ktmp = %kdat, %kdat = ();
        %ltmp = %ldat, %ldat = () if $bw;
        while ($l < $r){
            ($l, $x) = &readw($fh, $l);
            if ($ini || $ktmp{$x}){
                $kdat{$x} = 1;
                if ($bw){
                    $buf = &readindexindex($x);
                    $bw = 0, next if $ini && ($buf =~ /$str/);
                    $bstr = $pre, $ldat{$x} = 1 if $buf =~ /$pre$/;
                }
            }
        }
        $match = !$bw, $ini = 0 if $ini;
        %ldat = %ltmp if $bw && !%ldat;
        last if !%kdat;
    }

    if ($match){
        $pre = $origkey;
        $key = '';
    }elsif (%ldat){
        %kdat = %ldat;
        $str = "$bstr\$";
        ($key = $origkey) =~ s/^(\*$bstr)//;
        $pre = $1;
    }elsif ($origkey =~ s/^(\*\xa4[\xa1-\xf3](\xa4[\a1-\xf3]|\xa1\xbc)*)//){
        return ($1, $origkey, 0);
    }else{
        return ($origkey, '', 0);
    }

    my $wordcnt = 0;
    foreach $x (sort {$a <=> $b} keys(%kdat)){
        if (&ssub(\$totalhit, $x, *score, $pre, $str)){
            %score = () if $MaxHit && $totalhit >= $MaxHit;
            undef %{$SubHit{$pre}} if $MaxMatch && ++$wordcnt >= $MaxMatch;
        }
    }
    if ($MaxHit && $totalhit >= $MaxHit){
        $totalhit = 0;
        %score = ('TooMany' => $Text{'hit'});
    }elsif ($MaxMatch && $wordcnt >= $MaxMatch){
        $totalhit = 0;
        %score = ('TooMany' => $Text{'match'});
    }
    return ($pre, $key, $totalhit);
}
1;
#------------------ End of 'backward search' Module ------------------
