
my %format_para;
my @format_stack;
my $format_disable;

sub pagehref{
    my ($page, $akey) = @_;
    my $wh = $Max * int($page);

    push(@OriginalQuery, "whence=$wh") if !(grep {s/^whence.*/whence=$wh/} @OriginalQuery) && $wh;

    my $url = sprintf("%s?%s", $SCRIPT_NAME . $PathInfo, join('&', @OriginalQuery));
    $url = &metach($url);
    my $href = "<a href=\"$url\"";
    $href .= " accesskey=\"$akey\"" if $Phone && defined $akey;
    $href .= ">";
    return ($url, $href);
}

sub format_init{
    %format_para = (
                    'start_time' => localtime($^T) . "",
                    'current_time' => sub {localtime(time) . ""},
                    'time_to_search' => time - $^T,
                    'time_to_current' => sub {time - $^T},
                    'cgi' => $SCRIPT_NAME,
                    'pnamazu' => "pnamazu-$Pnamazu",
                    'key' => $KeyStr,
                    'quotekey' => &quote_meta($KeyStr),
                    'reference' => ($Reference !~ /^off/i),

                    'whence' => $Whence + 1,
                    'whither' => $Max? ($Whence + $Max): $Keys,
                    'hit' => $Keys,

                    'lang' => &get_language,
                    'code' => &get_output_ja_code,
                    );
    $format_para{'whither'} = $Keys if $Keys < $format_para{'whither'};
    $format_para{'page_index'} = ($format_para{'whence'} != 1
                                  || $format_para{'whither'} != $Keys);

    if ($format_para{'whence'} > 1){
        my ($url, $href) = &pagehref(($Whence - 1) / $Max);
        $format_para{'prev'} = 1;
        $format_para{'prev_url'} = $url;
        $format_para{'prev_href'} = $href;
    }
    if ($format_para{'whither'} < $Keys){
        my ($url, $href) = &pagehref(($Whence + $Max) / $Max, "\#");
        $format_para{'next'} = 1;
        $format_para{'next_url'} = $url;
        $format_para{'next_href'} = $href;
    }
}

sub format_num{
    my $page = int shift;
    my ($url, $href) = &pagehref($page);

    $format_para{'page_current'} = ($page * $Max == $Whence);

    $format_para{'page_number'} = $page + 1;
    $format_para{'page_url'} = $url;
    $format_para{'page_href'} = $href;
}

sub format_getline{
    my $x = shift;
    my $str;
    if (ref $x eq 'ARRAY'){
        $str = shift @$x;
    }else{
        $str = &str2euc($str) if defined($str = <$x>);
    }
    return $str;
}

sub format_replace{
    my $str = shift;
    $str = $format_para{$str};
    return $$str if ref $str eq 'SCALAR';
    return &$str if ref $str eq 'CODE';
    return $str;
}

sub format_string{
    my $str = shift;
    $str =~ s/\$\{([^\}]+)\}/&format_replace($1)/ge;
    return $str;
}

sub format_title{
    &format_init;
    $format_para{'title'} = shift;
    &format_string($TitleFormat);
}

sub format_check_stack{
    $format_disable = 0;
    for $str (@format_stack){
        $format_disable = 1 unless $str;
    }
}

sub format{
    my $x = shift;

    while (defined(my $str = &format_getline($x))){
        if ($str =~ /^\#if\s+(\S+)/){
            push(@format_stack, $format_para{$1});
            $format_disable = 1 unless $format_para{$1};
            next;
        }

        if ($str =~ /^\#endif/){
            &format_check_stack unless pop(@format_stack);
            next;
        }

        if ($str =~ /^\#else/ && @format_stack){
            $format_stack[$#format_stack] = !$format_stack[$#format_stack];
            &format_check_stack;
            next;
        }
        next if $format_disable;

        if ($str !~ /^\#/){
            &output(&format_string($str));
            next;
        }

        if ($str =~ s/^\#eval\s+//){
            $str = &format_string($str);
            $str = eval $str;
            &output($str);
            next;
        }

        &output($SList), &disp_error, next if $str =~ /^\#word/;
        &puthlist, &disp_error, next if $str =~ /^\#result/;

        if ($str =~ /^\#include/){
            my $file = $str;
            $file =~ s/^\#include\s+//;
            $file = &format_string($file);
            local(*FORMAT);
            if (open(FORMAT, $file)){
                &format(*FORMAT);
                close(FORMAT);
            }
            next;
        }

        if ($str =~ /^\#pageloop/){
            my @loop = ();
            while (defined($str = &format_getline($x))){
                last if $str =~ /^\#endloop/;
                push(@loop, $str);
            }
            my $wh;
            for ($wh = 0; $wh < $Keys; $wh += $Max){
                my @tmp = @loop;
                &format_num($wh / $Max);
                &format(\@tmp) while @tmp;
            }
            &disp_error;
            next;
        }

    }
}
1;
