#! /usr/local/bin/perl5 -w
# -*- Perl -*-
#
# lnnmz - program to make NMZ.field.link
#         by osamu2001@livedoor.com
# modified by furukawa@tcp-ip.or.jp
#

{
    my($tmp) = $0;
    $tmp = "./$tmp" if $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}
use strict;
require 'nmzidx.pl';

my $backup;
while (@ARGV && $ARGV[0] =~ s/^\-//){
    my $argv = shift;

    &usage, exit if $argv eq '-help';
    $backup = 0, next if $argv eq '-no-backup';

    while ($argv =~ s/^(.)//){
        $backup = 0 if $1 eq 'b';
    }
}

if (@ARGV){
    for my $argv (@ARGV){
        $argv =~ s/NMZ$// unless -d $argv;
        $argv = '.' if $argv eq '';
        &lnnmz($argv, $backup) if -d $argv;
    }
}else{
    &lnnmz('.', $backup);
}

sub lnnmz{
    my ($dir, $backup) = @_;

    my $nmzi = new nmzidx($dir, 'r');
    my $fh = $nmzi->open_flist;

    my $nmzo = new nmzidx($dir, 'w');
    my $fo = $nmzo->open_field('link');

    my %list_f;
    while (defined $fh->read(\%list_f)){
        my $file_name = $list_f{'r'};
        my %output = ();
        my $ndx = 0;
        if (open(IN, $file_name)){
            while (defined(my $str = <IN>)){
                while ($str =~ /<a\s[^>]*href=([\"\'])(http:\/\/.*?)\1/ig){ #"
                    $output{$2} = $ndx++ unless exists $output{$2};
                }
            }
            close(IN);
        }
        my $ret;
        my $pre = '';
	$fo->{'link'}->putline(join(" ", sort {$output{$a} <=> $output{$b}} keys %output) . "\n");
    }
    $nmzo->replace_db($backup);
    $nmzi->close;
}

sub usage{
    print
        ("Usage: lnnmz [options] <target(s)>\n" .
         "  --help              show this help and exit.\n" .
         "  -b, --no-backup     do not backup original file.\n" .
         );
}
